import winston from 'winston';

const mp3 = "audio/mpeg";
const opus = "audio/ogg";
const wav = "audio/wav";
const mp4 = "video/mp4";
const supportedFormats = {
  mp3,
  opus,
  wav,
  mp4
};

const logger = winston.createLogger({
  level: "error",
  format: winston.format.json(),
  transports: [new winston.transports.Console()]
});
const formatMime = new Map(Object.entries(supportedFormats));
const isURLValid = (url) => {
  try {
    new URL(url);
  } catch {
    return false;
  }
  return true;
};
const mimeTypeMap = formatMime;

export { isURLValid as i, logger as l, mimeTypeMap as m };
//# sourceMappingURL=helpers-miOV2pjS.js.map
